#ifndef STRUCT_H
#define STRUCT_H


#include "imapfilter.h"
#include "account.h"


/*
 * Find last node of linked list and append at the end of the list the
 * supplied node.
 */
#define APPEND_LINKED_LIST(FIRST, NODE, TYPE)				\
{									\
	struct TYPE *POS;						\
	struct TYPE **APP;						\
	POS = FIRST;							\
	APP = &FIRST;							\
	while (POS) {							\
		APP = &(POS->next);					\
		POS = POS->next;					\
	}								\
	*APP = NODE;							\
}

/*
 * Find, based on the key of the supplied node, the apropriate position for it
 * in the tree, and then insert it there.
 */
#define INSERT_TREE(ROOT, NODE, TYPE)					\
{									\
	int CMP;							\
	struct TYPE *POS;						\
	struct TYPE **INS;						\
	INS = &ROOT;							\
	POS = ROOT;							\
	while (POS) {							\
		CMP = strncmp(NODE->key, POS->key, KEY_LEN);		\
		if (CMP < 0) {						\
			INS = &(POS->left);				\
			POS = POS->left;				\
		} else if (CMP > 0) {					\
			INS = &(POS->right);				\
			POS = POS->right;				\
		} else							\
			return ERROR_CONFIG_PARSE;			\
		}							\
	*INS = NODE;							\
}

/*
 * Find, based on the key, the position of a node, and set accordingly the
 * pointer supplied.
 */
#define FIND_TREE(ROOT, KEY, PTR)					\
{									\
	int CMP;							\
	PTR = ROOT;							\
	while (PTR) {							\
		CMP = strncmp(KEY, PTR->key, KEY_LEN);			\
		if (CMP < 0)						\
			PTR = PTR->left;				\
		else if (CMP > 0)					\
			PTR = PTR->right;				\
		else							\
			 break;						\
	}								\
}


#endif				/* STRUCT_H */
